package com.yihaomen.shardingjava;

import java.util.List;

import javax.annotation.Resource;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import com.yihaomen.shardingjava.entity.UserInfo;
import com.yihaomen.shardingjava.service.UserService;

/**
 * 演示取模的分库分表策略
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class UserShardingTest {
	@Resource
    UserService userService;

	@Test
	public void insert(){
		userService.insert();
	}

	@Test
	public void select(){
		UserInfo userInfo1= userService.getUserInfoByUserId(1L);
		System.out.println("------userInfo1:"+userInfo1);

        UserInfo userInfo2= userService.getUserInfoByUserId(2L);
        System.out.println("------userInfo2:"+userInfo2);
	}
	
	@Test
	public void insertAccount() {
		userService.insertAccount();
	}
	
	@Test
	public void selectByRange() {
		List<UserInfo> users = userService.selectByRange(1L, 10L);
		for (UserInfo userInfo : users) {
			System.out.println(userInfo.getUserId());
		}
	}
	
	@Test
	public void selectPagination() {
		List<UserInfo> users = userService.selectPagination(2L, 2L);
		for (UserInfo userInfo : users) {
			System.out.println(userInfo.getAccount());
		}
	}
	
	@Test
	public void selectCount() {
		Long count = userService.selectCount(2L, 100L);
		System.out.println("total count: " + count);
	}
	
	@Test
	public void selectLikeTest() {
		List<UserInfo> users = userService.selectByLikeTest();
		for (UserInfo userInfo : users) {
			System.out.println(userInfo.getAccount());
		}
	}

}
